# en.pm - The Object Class that provides a English Language Object
# Created by James Pattie & Jason A. Pattie, 11/07/2000.
#$Id: en.pm,v 1.39 2004/09/29 21:48:26 moreejt Exp $
#This package is released under the GNU General Public License.
#You should have recieved a copy of the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.

package Portal::Accounting::Language::en;
use strict;
use vars qw($AUTOLOAD $VERSION @ISA @EXPORT);

require Exporter;

@ISA = qw(Exporter AutoLoader);
@EXPORT = qw();

$VERSION = '0.02';

# The Phrases/words should be in the same case as the output should be for ex.
#$phrases{Accrual} = "Accrual";
#$phrases{accrual} = "accrual";
# spaces can be replaced with underscores in short phrases
#long phrases should be given a shortkeyphrase and placed in the lower section

my %phrases;
%phrases = ();

#short phrases
$phrases{account} = "account";
$phrases{Account} = "Account";
$phrases{accounts} = "accounts";
$phrases{Accounts} = "Accounts";
$phrases{Accrual} = "Accrual";
$phrases{'All Accounts'} = "All Accounts";
$phrases{Amount} = "Amount";
$phrases{assets} = "assets";
$phrases{Assets} = "Assets";
$phrases{Assigned} = "Assigned";
$phrases{AssignedAccounts} = "Assigned Accounts";
$phrases{AssignAllTickers} = "Assign All Tickers";
$phrases{Available} = "Available";
$phrases{avgCostPerShare} = "C/S";
$phrases{Balance} = "Balance";
$phrases{Bank_Account_Summary} = "Bank Account Summary";
$phrases{Begins_on} = "Begins on";
$phrases{'Business Type'} = "Business Type";
$phrases{'Capital Gains'} = "Capital Gains";
$phrases{Cash} = "Cash";
$phrases{Chk} = "Chk";
$phrases{Cash_Balance} = "Cash Balance";
$phrases{Change} = "Change";
$phrases{'Choose Register'} = "Choose Register";
$phrases{clientUserName} = "Client User Name";
$phrases{Cld} = "Cld";
$phrases{'Close Books'} = "Close Books";
$phrases{'Close Out'} = "Close Out";
$phrases{close} = "close";
$phrases{Close} = "Close";
$phrases{Close_Window} = "Close Window";
$phrases{code} = "code";
$phrases{Code} = "Code";
$phrases{'Common Accounts'} = "Common Accounts";
$phrases{Company} = "Company";
$phrases{Comment} = "Comment";
$phrases{"Corporation"} = "Corporation";
$phrases{Configuration} = "Configuration";
$phrases{'Config_Menu'} = "Config Menu";
$phrases{create} = "create";
$phrases{Create} = "Create";
$phrases{created} = "created";
$phrases{date} = "date";
$phrases{Date} = "Date";
$phrases{day} = "day";
$phrases{Day} = "Day";
$phrases{delete} = "delete";
$phrases{Delete} = "Delete";
$phrases{'Delete Sub Entity'} = "Delete Sub Entity";
$phrases{Departments} = "Departments";
$phrases{Dep} = "Dep";
$phrases{displayZeroShares} = "Display Zero Shares";
$phrases{edit} = "edit";
$phrases{Edit} = "Edit";
$phrases{Edit_List} = "Edit List";
$phrases{'Edit Sub Entity'} = "Edit Sub Entity";
$phrases{emails} = "e-mails";
$phrases{Emails} = "E-mails";
$phrases{Employees} = "Employees";
$phrases{endDate} = "End Date";
$phrases{Ends_on} = "Ends on";
$phrases{entry} = "entry";
$phrases{Entry} = "Entry";
$phrases{Error} = "Error";
$phrases{execute} = "execute";
$phrases{Execute} = "Execute";
$phrases{Fed_Deposit} = "Federal Deposit";
$phrases{FiscalYear} = "Fiscal Year";
$phrases{for} = "for";
$phrases{found} = "found";
$phrases{From} = "From";
$phrases{gainLoss} = "G/L";
$phrases{go} = "go";
$phrases{Go} = "Go";
$phrases{help} = "help";
$phrases{Help} = "Help";
$phrases{here} = "here";
$phrases{id} = "Id";
$phrases{inClientMode} = "In Client Mode.\n";
$phrases{"Individual"} = "Individual";
$phrases{Industry} = "Industry";
$phrases{'Initial Balances'} = 'Initial Balances';
$phrases{inNormalMode} = "In Normal Mode.\n";
$phrases{interval} = "interval";
$phrases{Interval} = "Interval";
$phrases{InvalidWatchListName} = "Invalid Watch List name (%s)!";
$phrases{invalidPassword} = "Password is invalid!";
$phrases{investmentAccounts} = "Investment Accounts";
$phrases{investmentJournal} = "Investment Journal";
$phrases{Investments} = "Investments";
$phrases{Last} = "Last";
$phrases{'Last Close Out'} = "Last Close Out";
$phrases{LedgerCode} = "Ledger Code";
$phrases{LedgerColor} = "Ledger Color";
$phrases{ledger} = "ledger";
$phrases{Ledger} = "Ledger";
$phrases{LedgerName} = "Ledger Name";
$phrases{Ledger_Required} = "Ledger Required!";
$phrases{Ledgers} = "Ledgers";
$phrases{'Ledger Summary'} = "Ledger Summary";
$phrases{"Limited Liability Co"} = "Limited Liability Co";
$phrases{links} = "links";
$phrases{login} = "login";
$phrases{Login} = "Login";
$phrases{logout} = "logout";
$phrases{Logout} = "Logout";
$phrases{MailType} = "Mail Type";
$phrases{MailServer} = "Mail Server";
$phrases{Main_Menu} = "Main Menu";
$phrases{maintainStocks} = "Maintain Stocks";
$phrases{Manual_Price} = "Manual Price";
$phrases{Mark} = "Mark";
$phrases{Market} = "Market";
$phrases{'Mkt Val'} = "Mkt Val";
$phrases{monitor} = "monitor";
$phrases{Monitor} = "Monitor";
$phrases{month} = "month";
$phrases{Month} = "Month";
$phrases{Name} = "Name";
$phrases{New_Frame} = "New Frame";
$phrases{New} = "New";
$phrases{'New Sub Entity'} = "New Sub Entity";
$phrases{New_Transaction} = "New Transaction";
$phrases{New_Window} = "New Window";
$phrases{noEntriesFound} = "No Entries found";
$phrases{'No Watchlists defined'} = "No Watchlists defined";
$phrases{'Open Books'} = "Open Books";
$phrases{Open} = "Open";
$phrases{operator} = "operator";
$phrases{Operator} = "Operator";
$phrases{Options} = "Options";
$phrases{orderBy} = "Order By";
$phrases{Outstanding} = "Outstanding";
$phrases{"Partnership"} = "Partnership";
$phrases{password} = "password";
$phrases{Password} = "Password";
$phrases{percentChange} = "%";
$phrases{Portfolio} = "Portfolio";
$phrases{Power_Search} = "Power Search";
$phrases{Preferences} = "Preferences";
$phrases{Price} = "Price";
$phrases{print} = "print";
$phrases{Print} = "Print";
$phrases{Quarter} = "Quarter";
$phrases{Quick_Search} = "Quick Search";
$phrases{Reconcile} = "Reconcile";
$phrases{refresh} = "refresh";
$phrases{Refresh} = "Refresh";
$phrases{Register} = "Register";
$phrases{Registers} = "Registers";
$phrases{Reports} = "Reports";
$phrases{reset} = "reset";
$phrases{Reset} = "Reset";
$phrases{run} = "run";
$phrases{Run} = "Run";
$phrases{Save} = "Save";
$phrases{'Save Sub Entity'} = "Save Sub Entity";
$phrases{Search} = "Search";
$phrases{'select all'} = "select all";
$phrases{'Select All'} = "Select All";
$phrases{Select} = "Select";
$phrases{"Sole Proprietorship"} = "Sole Proprietorship";
$phrases{startDate} = "Start Date";
$phrases{stockPrices} = "Stock Prices";
$phrases{stocks} = "stocks";
$phrases{Stocks} = "Stocks";
$phrases{'Sub Entity'} = "Sub Entity";
$phrases{'Sub Entities'} = "Sub Entities";
$phrases{'Sub-Accounts'} = "Sub-Accounts";
$phrases{Submit} = "Submit";
$phrases{Success} = "Success";
$phrases{successfully} = "successfully";
$phrases{Summary} = "Summary";
$phrases{Symbol} = "Symbol";
$phrases{title} = "XIWA %s - %s";
$phrases{To} = "To";
$phrases{to_begin_working} = "to begin working";
$phrases{toCreateStocks} = "to create Stocks.";
$phrases{toMaintainStocks} = "to maintain Stocks.";
$phrases{totalCost} = "Cost";
$phrases{totalShares} = "Shares";
$phrases{Ticker} = "Ticker";
$phrases{"Trust"} = "Trust";
$phrases{Unassigned} = "Unassigned";
$phrases{unAssignAllTickers} = "Un-assign All Tickers";
$phrases{unSelectAll} = "un-Select All";
$phrases{UnSelectAll} = "Un-Select All";
$phrases{unSelect} = "un-Select";
$phrases{UnSelect} = "Un-Select";
$phrases{updated} = "updated";
$phrases{Update} = "Update";
$phrases{users} = "users";
$phrases{Users} = "Users";
$phrases{volumeTraded} = "Vol(M)";
$phrases{WatchList} = "WatchList";
$phrases{Watchlists} = "Watchlists";
$phrases{watchedStocks} = "Watched Stocks";
$phrases{week} = "week";
$phrases{xiwa} = "xiwa";
$phrases{Year} = "Year";

#long phrases
$phrases{accountDoesNotExistInDatabase} = "Account (%s) = %s does not exist in the database!";
$phrases{accountNotActive} = "Account (%s) = %s is not active!";
$phrases{accountNotAnEquityAccount} = "Account (%s) = %s is not an Equity Account!";
$phrases{accountNotAssignedToLedger} = "Account (%s) = %s does not appear to be assigned to ledger = %s!";
$phrases{alreadyWatchingStock} = "You are already Watching Stock";
$phrases{appStateCommand} = "App = '%s', State = '%s', Command = '%s'.";
$phrases{appVersion} = "Accounting Version = <font color=\"%s\">%s</font>";
$phrases{basis} = "Accounting Basis";
$phrases{chooseLeftoverEquityAccount} = "You must choose an account to assign left over cents to!";
$phrases{chooseOneEquityAccount} = "You must choose a single equity account to work with!";
$phrases{chooseStockInfo} = "Choose Stock Information";
$phrases{chooseStocksManually} = "You must choose stocks to manually update price!";
$phrases{ChooseTickersForWatchList} = "You must choose tickers to assign to the Watch List (%s)!";
$phrases{chooseTwoOrMoreEquityAccounts} = "You must choose two or more equity accounts to work with!";
$phrases{closeMessage} = "Press 'OK' if you really want to Close this Application,\\nelse press 'Cancel'.";
$phrases{close_lock} = "Close/Lock books up to this date:";
$phrases{closeNote} = "Note: Income summary is Revenues minus Expenses minus Dividends Declared/Paid.";
$phrases{closeoutDateInvalid} = "Closeout date is invalid!  '%s' must be after '%s'.";
$phrases{closeoutExplain} = "Revenues and Expenses for the year will be rolled into an equity account and set to 0 to start the next year.  Which equity account should be used?";
$phrases{commandNeeded} = "The Command to execute must be specified!";
$phrases{commandNotKnown} = "Command = '%s' is not known!";
$phrases{confirmCloseApp} = "Do you really want to Close this Application?";
$phrases{confirmDeleteWatchList} = "Do you really want to delete this Watch List?";
$phrases{creditsGreaterThanDebits} = "Credits are greater than Debits!";
$phrases{cumulativeDates} = "Choose a date.  All closeout periods on and after this date will be opened.";
$phrases{dateInfo} = "Historical Date Info";
$phrases{debitsGreaterThanCredits} = "Debits are greater than Credits!";
$phrases{DeleteLedger} = "Do you want to Delete Ledger '%s'?";
$phrases{DeletionOfWatchListFailed} = "Deletion of Watch List (%s): failed";
$phrases{DeletionOfWatchListSucceeded} = "Deletion of Watch List (%s): succeeded";
$phrases{DeleteWatchList} = "Delete Watch List (%s)?";
$phrases{'Edit WatchLists'} = "Edit WatchLists";
$phrases{enterListOfCommaSeparatedTickers} = "You must enter a list of comma-separated ticker sybmols (without empty entries).";
$phrases{equityAccountsArrayReferenceRequired} = "equityAccounts must be specified as an array reference!";
$phrases{errorClosingOutLedger} = "Error occurred closing out ledger = '%s', date = '%s'!";
$phrases{errorCommittingTransaction} = "Error occurred committing transaction to the database!";
$phrases{errorCreatingNextFiscalYear} = "Error occurred creating next fiscal year record (%s), begin date = '%s', end date = '%s'!";
$phrases{errorCreatingRetainedEarningsBalanceForEquityAccount} = "Error creating default balance table entry for equity account = '%s', retained earnings = '%s', date = '%s'!";
$phrases{errorCreatingRetainedEarningsBalanceForEquitySubAccount} = "Error creating default balance table entry for equity account = '%s', sub-account = '-1', retained earnings = '%s', date = '%s'!";
$phrases{errorCreatingRetainedEarningsBalanceForLeftoverEquityAccount} = "Error creating default balance table entry for leftover equity account = '%s', leftover amount = '%s', date = '%s'!";
$phrases{errorCreatingRetainedEarningsBalanceForLeftoverEquitySubAccount} = "Error creating default balance table entry for leftover equity account = '%s', sub-account = '-1', leftover amount = '%s', date = '%s'!";
$phrases{errorCreatingRetainedEarningsBalanceForPartnerEquityAccount} = "Error creating default balance table entry for partner equity account = '%s', partner amount = '%s', date = '%s'!";
$phrases{errorCreatingRetainedEarningsBalanceForPartnerEquitySubAccount} = "Error creating default balance table entry for partner equity account = '%s', sub-account = '-1', partner amount = '%s', date = '%s'!";
$phrases{errorCreatingRetainedEarningsBalanceForShareholderEquityAccount} = "Error creating default balance table entry for shareholder equity account = '%s', partner amount = '%s', date = '%s'!";
$phrases{errorCreatingRetainedEarningsBalanceForShareholderEquitySubAccount} = "Error creating default balance table entry for shareholder equity account = '%s', sub-account = '-1', partner amount = '%s', date = '%s'!";
$phrases{errorExclam} = "Error!";
$phrases{errorFixingUpDate} = "Error occurred attempting to fixup date = %s";
$phrases{errorGettingLastCloseoutPeriod} = "Error retrieving last closeout period date for ledger = %s.";
$phrases{errorInsertingAccountBalances} = "Error inserting account balances into acct_bal_tb table!";
$phrases{errorInsertingSubAccountBalances} = "Error inserting sub-account balances into acct_bal_tb table!";
$phrases{errorLookingUpBalanceForEquityAccount} = "Error occurred looking up balance for equity account = '%s'!";
$phrases{errorLookingUpBalanceForEquitySubAccount} = "Error occurred looking up balance for equity account = '%s', sub-account = '-1'!";
$phrases{errorLookingUpBalanceForPartnerEquityAccount} = "Error occurred looking up balance for partner equity account = '%s'!";
$phrases{errorLookingUpBalanceForPartnerEquitySubAccount} = "Error occurred looking up balance for partner equity account = '%s', sub-account = '-1', business type = '%s'!";
$phrases{errorLookingUpBalanceForPartnerLeftoverEquityAccount} = "Error occurred looking up balance for partner leftover equity account = '%s'!";
$phrases{errorLookingUpBalanceForShareholderEquityAccount} = "Error occurred looking up balance for shareholder equity account = '%s'!";
$phrases{errorLookingUpBalanceForShareholderEquitySubAccount} = "Error occurred looking up balance for shareholder equity account = '%s', sub-account = '-1', business type = '%s'!";
$phrases{errorLookingUpBalanceForShareholderLeftoverEquityAccount} = "Error occurred looking up balance for shareholder leftover equity account = '%s'!";
$phrases{errorLookingUpBalanceForShareholderLeftoverEquitySubAccount} = "Error occurred looking up balance for shareholder leftover equity account = '%s', sub-account = '-1', business type = '%s'!";
$phrases{errorLookingUpCloseouts} = "Error looking up closeouts for ledger after date = '%s'.";
$phrases{errorLookingUpCurrentFiscalCloseoutDates} = "Error occurred while attempting to lookup the current fiscal year closeout dates.";
$phrases{errorLookingUpCurrentFiscalYearForLedger} = "Error occurred looking up current fiscal year for ledger = '%s'!";
$phrases{errorLookingUpFiscalYearEnd} = "Error occurred looking up the fiscal year end date for fiscal year = '%s'!";
$phrases{errorLookingUpMinimumKnownYear} = "Error occurred looking up the minimum known year for ledger = '%s'!";
$phrases{errorLookingUpNextFiscalYear} = "Error occurred trying to see whether fiscal year = '%s' exists in the known years table or not.";
$phrases{errorLookingUpPreviousCloseoutDate} = "Error occurred while trying to retrieve the last previous closeout date!";
$phrases{errorLookingUpStockWatchListInfo} = "Error occured while attempting to lookup stock watch list information!";
$phrases{errorNoBalancedReturnedForPartnerEquitySubAccount} = "No balance was returned for partner equity account = '%s', sub-account = '-1'!";
$phrases{errorNoBalancedReturnedForLeftoverEquitySubAccount} = "No balance was returned for leftover equity account = '%s', sub-account = '-1'!";
$phrases{errorNoBalancedReturnedForShareholderEquitySubAccount} = "No balance was returned for shareholder equity account = '%s', sub-account = '-1'!";
$phrases{errorObtainingEndDateOffset} = "Error occurred obtaining next fiscal year end date!";
$phrases{errorObtainingNextBeginDateOffset} = "Error occurred obtaining next begin date offset, quarter = '%s'!";
$phrases{errorObtainingQuarterEndOffset} = "Error occurred obtaining quarter end offset, quarter = '%s'!";
$phrases{errorObtainingStartDateOffset} = "Error occurred obtaining next fiscal year start date!";
$phrases{errorOpeningFiscalYears} = "Error occurred marking all years >= '%s' as not being closed!";
$phrases{errorRemovingAccountBalances} = "Error occurred attempting to remove account balances in the working year = '%s'!";
$phrases{errorReOpeningLedger} = "Error occurred reopening ledger = '%s', date = '%s'!";
$phrases{errorRetrievingActivityForDividendsPaid} = "Error retrieving the activity for Dividends Paid accounts!";
$phrases{errorRetrievingActivityForExpenses} = "Error retrieving the activity for Expense accounts!";
$phrases{errorRetrievingActivityForRevenues} = "Error retrieving the activity for Revenue accounts!";
$phrases{errorSummingCredits} = "Error occurred summing credit amounts.";
$phrases{errorSummingDebits} = "Error occurred summing debit amounts.";
$phrases{errorUpdatingClosedFiscalYearRecord} = "Error occurred updating the closed fiscal year record (%s).";
$phrases{errorUpdatingNextFiscalYearQuarter} = "Error updating next fiscal year (%s), quarter = '%s', quarter start = '%s', quarter end = '%s'.";
$phrases{errorUpdatingNextFiscalYearRecord} = "Error occurred updating the next fiscal year record (%s).";
$phrases{errorUpdatingNewWorkingYear} = "Error occurred updating new working year for ledger = '%s', new working year = '%s'!";
$phrases{errorUpdatingRetainedEarningsBalanceForEquityAccount} = "Error updating balance table entry for equity account = '%s', balance amount = '%s', date = '%s'!";
$phrases{errorUpdatingRetainedEarningsBalanceForEquitySubAccount} = "Error updating balance table entry for equity account = '%s', sub-account = '-1', balance = '%s', date = '%s'!";
$phrases{errorUpdatingRetainedEarningsBalanceForLeftoverEquityAccount} = "Error updating balance table entry for leftover equity account = '%s', leftover balance amount = '%s', date = '%s'!";
$phrases{errorUpdatingRetainedEarningsBalanceForLeftoverEquitySubAccount} = "Error updating balance table entry for leftover equity account = '%s', sub-account = '-1', leftover balance amount = '%s', date = '%s'!";
$phrases{errorUpdatingRetainedEarningsBalanceForPartnerEquityAccount} = "Error updating balance table entry for partner equity account = '%s', partner balance amount = '%s', date = '%s'!";
$phrases{errorUpdatingRetainedEarningsBalanceForPartnerEquitySubAccount} = "Error updating balance table entry for partner equity account = '%s', sub-account = '-1', partner balance amount = '%s', date = '%s'!";
$phrases{errorUpdatingRetainedEarningsBalanceForShareholderEquityAccount} = "Error updating balance table entry for shareholder equity account = '%s', shareholder balance amount = '%s', date = '%s'!";
$phrases{errorUpdatingRetainedEarningsBalanceForShareholderEquitySubAccount} = "Error updating balance table entry for shareholder equity account = '%s', sub-account = '-1', shareholder balance amount = '%s', date = '%s'!";
$phrases{errorUpdatingWorkingYear} = "Error occurred updating the working year for reopening the fiscal period!";
$phrases{firstTimeRun} = "<img src=\"http://www.pcxperience.org/xiwa/firstrun.jpg\"><font color=\"red\">Congratulations!  You have successfully run XIWA.</font>";
$phrases{frameBrowser} = "You must have a frames capable browser!";
$phrases{glcCustomizationTitle} = "Capital Gain/Loss Customization Screen";
$phrases{'Ignoring invalid'} = "Ignoring invalid";
$phrases{inClientMode} = "In Client Mode.\n";
$phrases{Initial_Account_Balances} = "Initial Account Balances";
$phrases{inNormalMode} = "In Normal Mode.\n";
$phrases{invalidArgument} = "<b>%s</b> = '%s' is invalid";
$phrases{invalidCreditDate} = "Credit check: beginDate = '%s' or endDate = '%s' is invalid!";
$phrases{invalidDebitDate} = "Debit check: beginDate = '%s' or endDate = '%s' is invalid!";
$phrases{invalidLedger} = "ledger = '%s' is invalid!<br>\n";
$phrases{ledgerAlreadyClosed} = "Ledger has already been closed out after Date = '%s'.";
$phrases{manualPriceNeedsToBeSpecified} = "Manual Price entry field empty!  Manual Price value needs to be specified.";
$phrases{missingArgument} = "<b>%s</b> is missing";
$phrases{moreWatchedStocksReturned} = "More watched Stocks returned than Stocks are created!";
$phrases{negativeNumberFormatPhrase} = "Negative Number Format";
$phrases{noDates} = "No dates have been closed out yet.  There are none to open in the books.";
$phrases{noInformationReturnedFromFetch} = "No information returned from fetch operation!";
$phrases{noStocksCreated} = "No Stocks created!";
$phrases{noStockInfoReturned} = "No stock information was returned!";
$phrases{noStockInfoSuppliedReturned} = "No stock information was supplied, so no stock information can be returned!";
$phrases{noStocksReturned} = "No stocks were returned from the watched stocks table!";
$phrases{noTickeredStocksCreated} = "No Stocks created with Tickers!";
$phrases{noValidLedger} = "No valid ledgers are currently defined.  Click New to create one.";
$phrases{notEnoughPercentages} = "There should be the same number of percentages as there are equity accounts!";
$phrases{passwdNeeded} = "passwd must be specifed!";
$phrases{percentageInvalid} = "The percentage (%s) given for Equity Account (%s) is invalid!";
$phrases{pleaseWatchStocks} = "Please be sure to watch some stocks.";
$phrases{PleaseCreateLedger} = "Please Create a Ledger so you can configure Ledger specific options like Sub-Entities, Assigned Accounts, Employees and Assets.";
$phrases{portfolioCustomizationTitle} = "Portfolio Customization Screen";
$phrases{PopUpColorPicker} = "Pop Up Color Picker";
$phrases{SavingStockForWatchListFailed} = "Saving stock (%s) for Watch List (%s): failed";
$phrases{SavingWatchListSucceeded} = "Saving of Watch List (%s): succeeded";
$phrases{selectDate} = "You must select a date!";
$phrases{selectStockToUnWatch} = "You must select a Stock to Un-Watch!";
$phrases{selectStockToWatch} = "You must select a Stock to Watch!";
$phrases{sessionCookieNeeded} = "The Session Cookie must be defined!";
$phrases{sessionNotCreated} = "The Session does not exist but Session Cookie is defined!";
$phrases{stateEvalFailed} = "Eval of State = '%s' failed!<br>\nError = '%s'.";
$phrases{stateNeeded} = "The State of the Application must be specified!";
$phrases{stateNotKnown} = "State = '%s' is not known!";
$phrases{stockPriceInstructions} = "To select stocks to update prices for (current, historical, or manual) choose from the <b>Stocks</b> select box. &nbsp;If doing Historical prices, select the Start and End Date values and the Interval to group by. &nbsp;If doing Manual prices, select the Start date and enter a Manual Price value. &nbsp;Then Click Go!";
$phrases{stockPriceTitle} = "Stock Price Maintenance";
$phrases{subENote} = "Sub Entities are another way to divide up your data.  You could also use them as departments.";
$phrases{SubEntityInUse} = "The Sub Entity you tried to delete is being used in some transactions.  You cannot delete it.";
$phrases{sumOfEquityAccountPercentagesNot100} = "The sum of all Equity Account Percentages does not equal 100! Total Percentages = %s.";
$phrases{tickersFailedToLookup} = "These tickers failed to be looked up";
$phrases{unameNeeded} = "uname must be specified!";
$phrases{unknownBusinessType} = "Unknown Business Type (%s) in ledger = '%s'";
$phrases{UnWatchingAllStocksWhileSavingWatchListFailed} = "unWatchAllStocks while saving Watch List (%s): failed";
$phrases{updateCurrentStockPrice} = "Update Current Stock Price";
$phrases{updateHistoricalStockPrice} = "Update Historical Stock Price";
$phrases{updateManualStockPrice} = "Update Manual Stock Price";
$phrases{UpdateStartInfo} = "Update Start Info";
$phrases{userNotActive} = "User = '%s' is not active!";
$phrases{userNotFound} = "Could not find User = '%s'!";
$phrases{usethis} = "Use this button to quickly mark a range of checks or deposits with 'x'";
$phrases{xiwaConfigInfo} = "To configure Ledgers, Accounts, Sub-Accounts, Stocks, Sub-Entities, etc. use:";
$phrases{FromColon} = "From:";
$phrases{ToColon} = "To:";

# new
# instantiates an instance of the English Language Phrases.
sub new
{
  my $that = shift;
  my $class = ref($that) || $that;
  my $self = bless {}, $class;
  my %args = (  @_ );

  $self->{phrases} = { %phrases };
  $self->{encoding} = "iso-8859-1";

  # do validation
  $self->{error} = !$self->isValid;
  if ($self->{error})
  {
    $self->setError($self->{errorString});
  }

  return $self;
}

# isValid - Returns 0 or 1 to indicate if the object is valid.
sub isValid
{
  my $self = shift;
  my $error = 0;
  my $errorString = "";

  # do validation code here.

  if (length $errorString > 0)
  {
    $error = 1;
    $self->setError($errorString);
  }

  return !$error;
}

sub DESTROY
{
  my $self = shift;
}

sub AUTOLOAD  # act as though all calls are just queries, setting of values will not work.
{
  my $self = shift;
  my $type = ref($self) || die "$self is not an object";
  my $name = $AUTOLOAD;
  $name =~ s/.*://;	# strip fully-qualified portion
  unless (exists $self->{$name})
  {
    die "Can't access `$name' field in object of class $type";
  }
  return $self->{$name};
}

# setError
# requires: errorString
# returns: nothing
sub setError
{
  my $self = shift;
  my @callerArgs = caller(1);
  (my $subName = $callerArgs[3]) =~ s/^(.+)(::)([^:]+)$/$1->$3/;
  my $callerErrStr = "$subName$self->{errorPhrase}";

  if (scalar @_ == 1)
  {
    $self->{errorString} = $callerErrStr . @_[0];
  }
  else
  {
    my %args = ( @_ );
    if (!exists $args{errorString})  # make sure we get the errorString argument!
    {
      $self->setError("<b>errorString</b> is missing!<br>\n");
    }
    else
    {
      $self->{errorString} = $callerErrStr . $args{errorString};
    }
  }
  $self->{error} = 1;
}

# didErrorOccur
# returns the value of error.
sub didErrorOccur
{
  my $self = shift;

  return $self->{error};
}

# errorMessage
# returns the value of errorString
sub errorMessage
{
  my $self = shift;

  return $self->{errorString};
}

1;
__END__

=head1 NAME

en - Object used to build a English Object Class.

=head1 SYNOPSIS

  use Portal::Language::en;
  my $obj = Portal::Language::en->new;
  if ($obj->didErrorOccur())
  {
    die $obj->errorMessage();
  }

=head1 DESCRIPTION

en is a English class.

=head1 Exported FUNCTIONS

  scalar new(void)
    Creates a new instance of the Portal::Language::en
    object.

  bool isValid(void)
    Returns 0 or 1 to indicate if the object is valid.  The error will be
    available via errorMessage().

  void setError(errorString)
    Sets error = 1 and $self->{errorString} = errorString.

  scalar didErrorOccur(void)
    Returns the value of error.

  scalar errorMessage(void)
    Returns the value of errorString.

=head1 Exported VARIABLES

  hash   phrases  - converted phrases
  scalar encoding - content type encoding for document.

  NOTE:  All data fields are accessible by specifying the object
         and pointing to the data member to be modified on the
         left-hand side of the assignment.
         Ex.  $obj->variable($newValue); or $value = $obj->variable;

=head1 AUTHOR

PC & Web Xperience, Inc. (mailto:admin@pcxperience.com)

=head1 SEE ALSO

perl(1), Portal(3), Portal::Accounting(3)

=cut
